=== source/CMakeLists.txt ===
# -----------------------------------------------------------------------------
# Add components directories
# -----------------------------------------------------------------------------
add_subdirectory(wtf)
add_subdirectory(lib)
add_subdirectory(bin)

XGUIPRO_INCLUDE_CONFIG_FILES_IF_EXISTS()
