=== debian/control ===
Source: hvml-xgui-pro
Section: libs
Priority: optional
Maintainer: Vincent Wei <vincent@minigui.org>
Build-Depends: debhelper-compat (= 13), cmake, libwebkit2gtk-hvml-4.0-dev, libsoup2.4-dev, libssl-dev, libgtk-3-dev, hvml-dom-ruler, hvml-purc-bin, libhvml-purc-dev, libxml2, ninja-build, libcurl4-openssl-dev, libkf5kjs-dev
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://github.com/HVML/PurC

Package: hvml-xgui-pro
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: xGUI Pro is a modern, cross-platform, and advanced HVML renderer which is based on tailored WebKit.
